// Code generated by https://github.com/gagliardetto/anchor-go. DO NOT EDIT.

package khronos

import (
	"errors"
	ag_binary "github.com/gagliardetto/binary"
	ag_solanago "github.com/gagliardetto/solana-go"
	ag_format "github.com/gagliardetto/solana-go/text/format"
	ag_treeout "github.com/gagliardetto/treeout"
)

// CloseVault is the `closeVault` instruction.
type CloseVault struct {

	// [0] = [WRITE] depositAccount
	//
	// [1] = [WRITE] destinationAccount
	//
	// [2] = [WRITE] vault
	//
	// [3] = [WRITE] depositWithdrawnAccount
	//
	// [4] = [WRITE] destinationWithdrawnAccount
	//
	// [5] = [WRITE, SIGNER] authority
	//
	// [6] = [] vaultAuthority
	//
	// [7] = [] systemProgram
	//
	// [8] = [] tokenProgram
	//
	// [9] = [] rent
	ag_solanago.AccountMetaSlice `bin:"-"`
}

// NewCloseVaultInstructionBuilder creates a new `CloseVault` instruction builder.
func NewCloseVaultInstructionBuilder() *CloseVault {
	nd := &CloseVault{
		AccountMetaSlice: make(ag_solanago.AccountMetaSlice, 10),
	}
	return nd
}

// SetDepositAccountAccount sets the "depositAccount" account.
func (inst *CloseVault) SetDepositAccountAccount(depositAccount ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[0] = ag_solanago.Meta(depositAccount).WRITE()
	return inst
}

// GetDepositAccountAccount gets the "depositAccount" account.
func (inst *CloseVault) GetDepositAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(0)
}

// SetDestinationAccountAccount sets the "destinationAccount" account.
func (inst *CloseVault) SetDestinationAccountAccount(destinationAccount ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[1] = ag_solanago.Meta(destinationAccount).WRITE()
	return inst
}

// GetDestinationAccountAccount gets the "destinationAccount" account.
func (inst *CloseVault) GetDestinationAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(1)
}

// SetVaultAccount sets the "vault" account.
func (inst *CloseVault) SetVaultAccount(vault ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[2] = ag_solanago.Meta(vault).WRITE()
	return inst
}

// GetVaultAccount gets the "vault" account.
func (inst *CloseVault) GetVaultAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(2)
}

// SetDepositWithdrawnAccountAccount sets the "depositWithdrawnAccount" account.
func (inst *CloseVault) SetDepositWithdrawnAccountAccount(depositWithdrawnAccount ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[3] = ag_solanago.Meta(depositWithdrawnAccount).WRITE()
	return inst
}

// GetDepositWithdrawnAccountAccount gets the "depositWithdrawnAccount" account.
func (inst *CloseVault) GetDepositWithdrawnAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(3)
}

// SetDestinationWithdrawnAccountAccount sets the "destinationWithdrawnAccount" account.
func (inst *CloseVault) SetDestinationWithdrawnAccountAccount(destinationWithdrawnAccount ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[4] = ag_solanago.Meta(destinationWithdrawnAccount).WRITE()
	return inst
}

// GetDestinationWithdrawnAccountAccount gets the "destinationWithdrawnAccount" account.
func (inst *CloseVault) GetDestinationWithdrawnAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(4)
}

// SetAuthorityAccount sets the "authority" account.
func (inst *CloseVault) SetAuthorityAccount(authority ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[5] = ag_solanago.Meta(authority).WRITE().SIGNER()
	return inst
}

// GetAuthorityAccount gets the "authority" account.
func (inst *CloseVault) GetAuthorityAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(5)
}

// SetVaultAuthorityAccount sets the "vaultAuthority" account.
func (inst *CloseVault) SetVaultAuthorityAccount(vaultAuthority ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[6] = ag_solanago.Meta(vaultAuthority)
	return inst
}

// GetVaultAuthorityAccount gets the "vaultAuthority" account.
func (inst *CloseVault) GetVaultAuthorityAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(6)
}

// SetSystemProgramAccount sets the "systemProgram" account.
func (inst *CloseVault) SetSystemProgramAccount(systemProgram ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[7] = ag_solanago.Meta(systemProgram)
	return inst
}

// GetSystemProgramAccount gets the "systemProgram" account.
func (inst *CloseVault) GetSystemProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(7)
}

// SetTokenProgramAccount sets the "tokenProgram" account.
func (inst *CloseVault) SetTokenProgramAccount(tokenProgram ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[8] = ag_solanago.Meta(tokenProgram)
	return inst
}

// GetTokenProgramAccount gets the "tokenProgram" account.
func (inst *CloseVault) GetTokenProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(8)
}

// SetRentAccount sets the "rent" account.
func (inst *CloseVault) SetRentAccount(rent ag_solanago.PublicKey) *CloseVault {
	inst.AccountMetaSlice[9] = ag_solanago.Meta(rent)
	return inst
}

// GetRentAccount gets the "rent" account.
func (inst *CloseVault) GetRentAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(9)
}

func (inst CloseVault) Build() *Instruction {
	return &Instruction{BaseVariant: ag_binary.BaseVariant{
		Impl:   inst,
		TypeID: Instruction_CloseVault,
	}}
}

// ValidateAndBuild validates the instruction parameters and accounts;
// if there is a validation error, it returns the error.
// Otherwise, it builds and returns the instruction.
func (inst CloseVault) ValidateAndBuild() (*Instruction, error) {
	if err := inst.Validate(); err != nil {
		return nil, err
	}
	return inst.Build(), nil
}

func (inst *CloseVault) Validate() error {
	// Check whether all (required) accounts are set:
	{
		if inst.AccountMetaSlice[0] == nil {
			return errors.New("accounts.DepositAccount is not set")
		}
		if inst.AccountMetaSlice[1] == nil {
			return errors.New("accounts.DestinationAccount is not set")
		}
		if inst.AccountMetaSlice[2] == nil {
			return errors.New("accounts.Vault is not set")
		}
		if inst.AccountMetaSlice[3] == nil {
			return errors.New("accounts.DepositWithdrawnAccount is not set")
		}
		if inst.AccountMetaSlice[4] == nil {
			return errors.New("accounts.DestinationWithdrawnAccount is not set")
		}
		if inst.AccountMetaSlice[5] == nil {
			return errors.New("accounts.Authority is not set")
		}
		if inst.AccountMetaSlice[6] == nil {
			return errors.New("accounts.VaultAuthority is not set")
		}
		if inst.AccountMetaSlice[7] == nil {
			return errors.New("accounts.SystemProgram is not set")
		}
		if inst.AccountMetaSlice[8] == nil {
			return errors.New("accounts.TokenProgram is not set")
		}
		if inst.AccountMetaSlice[9] == nil {
			return errors.New("accounts.Rent is not set")
		}
	}
	return nil
}

func (inst *CloseVault) EncodeToTree(parent ag_treeout.Branches) {
	parent.Child(ag_format.Program(ProgramName, ProgramID)).
		//
		ParentFunc(func(programBranch ag_treeout.Branches) {
			programBranch.Child(ag_format.Instruction("CloseVault")).
				//
				ParentFunc(func(instructionBranch ag_treeout.Branches) {

					// Parameters of the instruction:
					instructionBranch.Child("Params[len=0]").ParentFunc(func(paramsBranch ag_treeout.Branches) {})

					// Accounts of the instruction:
					instructionBranch.Child("Accounts[len=10]").ParentFunc(func(accountsBranch ag_treeout.Branches) {
						accountsBranch.Child(ag_format.Meta("             deposit", inst.AccountMetaSlice.Get(0)))
						accountsBranch.Child(ag_format.Meta("         destination", inst.AccountMetaSlice.Get(1)))
						accountsBranch.Child(ag_format.Meta("               vault", inst.AccountMetaSlice.Get(2)))
						accountsBranch.Child(ag_format.Meta("    depositWithdrawn", inst.AccountMetaSlice.Get(3)))
						accountsBranch.Child(ag_format.Meta("destinationWithdrawn", inst.AccountMetaSlice.Get(4)))
						accountsBranch.Child(ag_format.Meta("           authority", inst.AccountMetaSlice.Get(5)))
						accountsBranch.Child(ag_format.Meta("      vaultAuthority", inst.AccountMetaSlice.Get(6)))
						accountsBranch.Child(ag_format.Meta("       systemProgram", inst.AccountMetaSlice.Get(7)))
						accountsBranch.Child(ag_format.Meta("        tokenProgram", inst.AccountMetaSlice.Get(8)))
						accountsBranch.Child(ag_format.Meta("                rent", inst.AccountMetaSlice.Get(9)))
					})
				})
		})
}

func (obj CloseVault) MarshalWithEncoder(encoder *ag_binary.Encoder) (err error) {
	return nil
}
func (obj *CloseVault) UnmarshalWithDecoder(decoder *ag_binary.Decoder) (err error) {
	return nil
}

// NewCloseVaultInstruction declares a new CloseVault instruction with the provided parameters and accounts.
func NewCloseVaultInstruction(
	// Accounts:
	depositAccount ag_solanago.PublicKey,
	destinationAccount ag_solanago.PublicKey,
	vault ag_solanago.PublicKey,
	depositWithdrawnAccount ag_solanago.PublicKey,
	destinationWithdrawnAccount ag_solanago.PublicKey,
	authority ag_solanago.PublicKey,
	vaultAuthority ag_solanago.PublicKey,
	systemProgram ag_solanago.PublicKey,
	tokenProgram ag_solanago.PublicKey,
	rent ag_solanago.PublicKey) *CloseVault {
	return NewCloseVaultInstructionBuilder().
		SetDepositAccountAccount(depositAccount).
		SetDestinationAccountAccount(destinationAccount).
		SetVaultAccount(vault).
		SetDepositWithdrawnAccountAccount(depositWithdrawnAccount).
		SetDestinationWithdrawnAccountAccount(destinationWithdrawnAccount).
		SetAuthorityAccount(authority).
		SetVaultAuthorityAccount(vaultAuthority).
		SetSystemProgramAccount(systemProgram).
		SetTokenProgramAccount(tokenProgram).
		SetRentAccount(rent)
}
